/************************************************************************
 *									*
 *		VurdVXe@ob|bmrvO		*
 *									*
 *				: R}hIt@C		*
 *		t@C	: cms.c					*
 *		쐬		: 91/04/01				*
 *									*
 ************************************************************************/

#include "pc_cns.h"

/*	֐	*/
static	CMS_TBL	*read_cms(FILE *);
static	CMD_TBL	*read_cmd(FILE *, int);
static	PRM_TBL	*read_prm(FILE *, int);
static	PRT_TBL	*read_prt(FILE *, int);
static	SEL_TBL	*read_sel(FILE *);
static	NUM_TBL	*read_num(FILE *);
static	NAM_TBL	*read_nam(FILE *);
static	GUD_TBL	*read_gud(FILE *);
static	char	*getstr(FILE *);
static  int	getnum(FILE *);
static	CMD_TBL	*search_cmd(CMS_TBL *, char *, char *);
static	PRM_TBL	*search_prm(CMD_TBL *, char *);

/*=======================================================================
 |
 |		R}hIt@Cǂݍ
 |
 |	void	read_cmdfile()
 |
 =======================================================================*/
void	read_cmdfile()
{
	FILE	*fp;		/* t@C|C^ */
	int	i;		/* [vJE^ */

	/* ICR}hIt@Cǂݍ */
	for (i = 0; i < 5; i++) {
		if (csg.fsg.cms_file[i][0] != '\0') {
			/* R}hIt@CI[v */
			if ((fp = fopen(csg.fsg.cms_file[i], "rb")) != NULL) {

				/* R}hIt@Cǂݍ */
				cmstbl[i] = read_cms(fp);

				/* R}hIt@CN[Y */
				fclose(fp);
			}
		}
	}

	/* ItCR}hIt@Cǂݍ */
	if ((fp = fopen(csg.fsg.loc_file, "rb")) != NULL) {

		/* R}hIt@Cǂݍ */
		loctbl = read_cms(fp);

		/* R}hIt@CN[Y */
		fclose(fp);
	}
}

/*=======================================================================
 |
 |		R}h^Cgǂݍ
 |
 |	CMS_TBL	*read_cms(fp)
 |
 |		char	*file_name;	R}ht@C
 |
 |		Ԓl			R}hIe[u|C^
 |
 =======================================================================*/
static	CMS_TBL	*read_cms(FILE *fp)
{
	CMS_TBL	*ptr;		/* R}hIe[u|C^ */

	ptr = talloc(sizeof(CMS_TBL));	/* m */

	ptr->title = getstr(fp);	/* ^Cgǂݍ */
	ptr->guide = getstr(fp);	/* ǂݍ */
	ptr->n = getnum(fp);		/* R}hǂݍ */
	ptr->ptr = read_cmd(fp, ptr->n); /* R}hf[^ǂݍ */

	return(ptr);
}

/*=======================================================================
 |
 |		R}hf[^ǂݍ
 |
 |	CMD_TBL	*read_cmd(fp, n)
 |
 |		FILE	*fp;		t@C|C^
 |		int	n;		R}h
 |
 |		Ԓl			R}he[u|C^
 |
 =======================================================================*/
static	CMD_TBL	*read_cmd(FILE *fp, int n)
{
	CMD_TBL	*ptr, *p;	/* R}he[u|C^ */

	if (n == 0)
		return(NULL);

	ptr = talloc(sizeof(CMD_TBL) * n);	/* m */

	for (p = ptr; n--; p++) {
		p->name = getstr(fp);	/* R}hǂݍ */
		p->guide = getstr(fp);	/* ǂݍ */
		p->n = getnum(fp);	/* p[^ތǂݍ */
		p->ptr = read_prm(fp, p->n); /* p[^ޓǂݍ */
	}

	return(ptr);
}

/*=======================================================================
 |
 |		p[^ރf[^ǂݍ
 |
 |	PRM_TBL *read_prm(fp, n)
 |
 |		FILE	*fp;		t@C|C^
 |		int	n;		p[^ތ
 |
 |		Ԓl			p[^ރe[u|C^
 |
 =======================================================================*/
static	PRM_TBL	*read_prm(FILE *fp, int n)
{
	PRM_TBL	*ptr, *p;	/* p[^ރe[u|C^ */

	if (n == 0)
		return(NULL);

	ptr = talloc(sizeof(PRM_TBL) * n);	/* m */

	for (p = ptr; n--; p++) {
		p->name = getstr(fp);		/* p[^ǂݍ */
		p->guide = getstr(fp);		/* ǂݍ */
		p->n = getnum(fp);		/* p[^ǂݍ */
		p->ptr = read_prt(fp, p->n); /* p[^f[^ǂݍ */
	}

	return(ptr);
}

/*=======================================================================
 |
 |		p[^f[^ǂݍ
 |
 |	PRT_TBL	*read_prt(fp, n)
 |
 |		FILE	*fp;		t@C|C^
 |		int	n;		p[^
 |
 |		Ԓl			p[^e[u
 |
 =======================================================================*/
static	PRT_TBL	*read_prt(FILE *fp, int n)
{
	PRT_TBL	*ptr, *p;	/* p[^e[u|C^ */

	if (n == 0)
		return(NULL);

	ptr = talloc(sizeof(PRT_TBL) * n);	/* m */

	for (p = ptr; n--; p++) {
		p->type = getnum(fp);		/* p[^ޓǂݍ */
		p->guide = getstr(fp);		/* ǂݍ */
		switch (p->type) {
		case KWD_SEL:	/*  */
			p->ptr.sel = read_sel(fp);
			break;
		case KWD_NUM:	/* l */
			p->ptr.num = read_num(fp);
			break;
		case KWD_NAM:	/* ̍ */
			p->ptr.nam = read_nam(fp);
			break;
		case KWD_MSG:	/*  */
			p->ptr.gud = read_gud(fp);
			break;
		}
	}

	return(ptr);
}

/*=======================================================================
 |
 |		Iڃf[^ǂݍ
 |
 |	SEL_TBL	*read_sel(fp)
 |
 |		FILE	*fp;		t@C|C^
 |
 |		Ԓl			Iڃe[u|C^
 |
 =======================================================================*/
static	SEL_TBL	*read_sel(FILE *fp)
{
	SEL_TBL	*ptr;		/* Iڃe[u|C^ */
	int	i;		/* [vJE^ */
	int	n;		/* Iڐ */

	n = getnum(fp);		/* Iڐǂݍ */
	ptr = talloc(sizeof(SEL_TBL)+sizeof(ptr->ptr) * n); /* m */
	ptr->n = n;

	for (i = 0; i < n; i++) {
		ptr->ptr[i][0] = getstr(fp); /* Iځi\jǂݍ */
		ptr->ptr[i][1] = getstr(fp); /* Iځíjǂݍ */
	}

	return(ptr);
}

/*=======================================================================
 |
 |		lڃf[^ǂݍ
 |
 |	NUM_TBL	*read_num(fp)
 |
 |		FILE	*fp;		t@C|C^
 |
 |		Ԓl			lڃe[u|C^
 |
 =======================================================================*/
static	NUM_TBL	*read_num(FILE *fp)
{
	NUM_TBL	*ptr;		/* lڃe[u|C^ */

	ptr = talloc(sizeof(NUM_TBL));	/* m */

	ptr->min_flg = getnum(fp);	/* ŏlwtOǂݍ */
	ptr->min = getnum(fp);		/* ŏlǂݍ */
	ptr->min_syc = getnum(fp);	/* ŏlVXe萔ǂݍ */
	ptr->max_flg = getnum(fp);	/* őlwtOǂݍ */
	ptr->max = getnum(fp);		/* őlǂݍ */
	ptr->max_syc = getnum(fp);	/* őlVXe萔ǂݍ */
	ptr->prmid = getstr(fp);	/* p[^hcǂݍ */
	ptr->sel = getstr(fp);		/* Iړǂݍ */

	return(ptr);
}

/*=======================================================================
 |
 |		̍ڃf[^ǂݍ
 |
 |	NAM_TBL	*read_nam(fp)
 |
 |		FILE	*fp;		t@C|C^
 |
 |		Ԓl			̍ڃe[u|C^
 |
 =======================================================================*/
static	NAM_TBL	*read_nam(FILE *fp)
{
	NAM_TBL	*ptr;		/* ̍ڃe[u|C^ */

	ptr = talloc(sizeof(NAM_TBL));	/* m */

	ptr->length = getnum(fp);	/* ő啶ǂݍ */
	ptr->sel = getstr(fp);		/* Iړǂݍ */
	ptr->ext1 = getstr(fp);		/* gqPǂݍ */
	ptr->ext2 = getstr(fp);		/* gqQǂݍ */

	return(ptr);
}

/*=======================================================================
 |
 |		ڃf[^ǂݍ
 |
 |	GUD_TBL	*read_gud(fp)
 |
 |		FILE	*fp;		t@C|C^
 |
 |		Ԓl			̍ڃe[u|C^
 |
 =======================================================================*/
static	GUD_TBL	*read_gud(FILE *fp)
{
	GUD_TBL	*ptr;		/* ڃe[u|C^ */

	ptr = talloc(sizeof(GUD_TBL));	/* m */

	ptr->length = getnum(fp);	/* ő啶ǂݍ */

	return(ptr);
}

/*=======================================================================
 |
 |		ǂݍ
 |
 |	char	*getstr(fp)
 |
 |		FILE	*fp;		t@C|C^
 |
 |		Ԓl			ǂݍ񂾕̃|C^
 |
 =======================================================================*/
static	char	*getstr(FILE *fp)
{
	char	*ptr;		/* |C^ */
	int	len;		/*  */

	len = getnum(fp);		/* ǂݍ */

	if (len != -1) {
		ptr = talloc(len + 1);		/* m */

		fread(ptr, 1, len, fp);		/* ǂݍ */
		ptr[len] = '\0';
	} else
		ptr = NULL;

	return(ptr);
}

/*=======================================================================
 |
 |		lǂݍ
 |
 |	int	getnum(fp)
 |
 |		FILE	*fp;		t@C|C^
 |
 |		Ԓl			ǂݍ񂾐l
 |
 =======================================================================*/
static	int	getnum(FILE *fp)
{
	int	n;		/* lf[^ */

	/* lf[^ǂݍ */
	fread(&n, sizeof(int), 1, fp);

	return(n);
}

/*=======================================================================
 |
 |		R}hIe[u
 |
 |	CMS_TBL	*search_cms(bufp)
 |
 |		char	*bufp;		R}hobt@
 |
 |		Ԓl			R}hIe[u|C^
 |
 =======================================================================*/
CMS_TBL	*search_cms(char *bufp)
{
	char	cmd_name[4];	/* R}h */
	char	prm_name[4];	/* p[^ */
	int	i;		/* [vJE^ */

	/* R}ho */
	for (i = 0; i < 3 && *bufp != '\0'; i++, bufp++)
		cmd_name[i] = *bufp;
	cmd_name[i] = '\0';

	/* p[^o */
	while (*bufp == ' ')
		bufp++;
	for (i = 0; i < 3 && *bufp != '\0'; i++, bufp++)
		prm_name[i] = *bufp;
	prm_name[i] = '\0';

	/* R}h */
	for (i = 0; i < 5; i++) {
		cmd_current = search_cmd(cmstbl[i], cmd_name, prm_name);
		if (cmd_current != NULL)
			return(cmstbl[i]);
	}
	return(NULL);
}

/*=======================================================================
 |
 |		R}he[u
 |
 |	CMD_TBL	*search_cmd(cmstp, cmd_name, prm_name)
 |
 |		CMS_TBL	*cmsp;		R}hIe[u|C^
 |		char	*cmd_name;	R}h
 |		char	*prm_name;	p[^
 |
 |		Ԓl			R}he[u|C^
 |
 =======================================================================*/
static	CMD_TBL	*search_cmd(CMS_TBL *cmstp, char *cmd_name, char *prm_name)
{
	int	i;		/* [vJE^ */
	CMD_TBL	*cmdtp;		/* R}he[u|C^ */

	if (cmstp == NULL)
		return(NULL);

	/* p[^ */
	for (i = 0, cmdtp = cmstp->ptr; i < cmstp->n; i++, cmdtp++) {
		if (strcmp(cmd_name, cmdtp->name) == 0) {
			prm_current = search_prm(cmdtp, prm_name);
			if (prm_current != NULL)
				return(cmdtp);
		}
	}

	return(NULL);
}

/*=======================================================================
 |
 |		p[^e[u
 |
 |	PRM_TBL	*search_prm(cmdtp, prm_name)
 |
 |		CMD_TBL	*cmdp;		R}he[u|C^
 |		char	*prm_name;	p[^
 |
 |		Ԓl			p[^ރe[u|C^
 |
 =======================================================================*/
static	PRM_TBL	*search_prm(CMD_TBL *cmdtp, char *prm_name)
{
	int	i;		/* [vJE^ */
	PRM_TBL	*prmtp;		/* p[^ރe[u|C^ */

	/* p[^ */
	for (i = 0, prmtp = cmdtp->ptr; i < cmdtp->n; i++, prmtp++) {
		if (prmtp->name == NULL)
			return(prmtp);
		if (strcmp(prm_name, prmtp->name) == 0)
			return(prmtp);
	}

	return(NULL);
}
